#ifndef __SIMPLE_CLI_H__
#define __SIMPLE_CLI_H__

#define INBUF_SIZE		256
#define true   1
#define false  0

#define console_printf	 		printf
#define usleep(msec) 			wiced_rtos_delay_microseconds(msec)
#ifndef ARRAYSIZE
#define ARRAYSIZE(a)			(sizeof(a) / sizeof(a[0]))
#endif

#define AP_NAME   			"WISE-1530"
#define	BLE_TARGET_NAME		"WiFiInt"

#define console_clrscr() console_printf("\033[2J\033[0;0H")
#define CONSOLE_NONE 			"\033[m"
#define CONSOLE_RED 			"\033[0;32;31m"
#define CONSOLE_LIGHT_RED 		"\033[1;31m"
#define CONSOLE_GREEN 			"\033[0;32;32m"
#define CONSOLE_LIGHT_GREEN 	"\033[1;32m"
#define CONSOLE_BLUE 			"\033[0;32;34m"
#define CONSOLE_LIGHT_BLUE 		"\033[1;34m"
#define CONSOLE_DARY_GRAY 		"\033[1;30m"
#define CONSOLE_CYAN 			"\033[0;36m"
#define CONSOLE_LIGHT_CYAN 		"\033[1;36m"
#define CONSOLE_PURPLE 			"\033[0;35m"
#define CONSOLE_LIGHT_PURPLE 	"\033[1;35m"
#define CONSOLE_BROWN 			"\033[0;33m"
#define CONSOLE_YELLOW 			"\033[1;33m"
#define CONSOLE_LIGHT_GRAY 		"\033[0;37m"
#define CONSOLE_WHITE 			"\033[1;37m"


#define SIMPLECLI_COMMANDS \
    { (char*) "simplecli",         simple_cli_console,       0, NULL, NULL, (char*) "IO test", (char*) "IO test"},



typedef int (*simple_func)(int index, char *string, int len, void *printer);

typedef struct simple_cmds {
	const char *string;
    int index;
	simple_func func;
} simple_cmds;

int simple_cli_console( int argc, char* argv[] );
void simple_cli_loop(void const *pc);
void simple_cli_wait_seconds_and_return(int wait);
int simple_cli_list(simple_cmds *cmds);

int GetStr_wait(char *inbuf, unsigned int *words);
char GetChar_wait();
int GetInt_wait();
int FindSpace(const char *str);

extern simple_cmds main_menu_cmds[];

#endif //__SIMPLE_CLI_H__
