/*
 * Copyright 2017, Cypress Semiconductor Corporation or a subsidiary of 
 * Cypress Semiconductor Corporation. All Rights Reserved.
 * 
 * This software, associated documentation and materials ("Software"),
 * is owned by Cypress Semiconductor Corporation
 * or one of its subsidiaries ("Cypress") and is protected by and subject to
 * worldwide patent protection (United States and foreign),
 * United States copyright laws and international treaty provisions.
 * Therefore, you may use this Software only as provided in the license
 * agreement accompanying the software package from which you
 * obtained this Software ("EULA").
 * If no EULA applies, Cypress hereby grants you a personal, non-exclusive,
 * non-transferable license to copy, modify, and compile the Software
 * source code solely for use in connection with Cypress's
 * integrated circuit products. Any reproduction, modification, translation,
 * compilation, or representation of this Software except as specified
 * above is prohibited without the express written permission of Cypress.
 *
 * Disclaimer: THIS SOFTWARE IS PROVIDED AS-IS, WITH NO WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, NONINFRINGEMENT, IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. Cypress
 * reserves the right to make changes to the Software without notice. Cypress
 * does not assume any liability arising out of the application or use of the
 * Software or any product or circuit described in the Software. Cypress does
 * not authorize its products for use in any products where a malfunction or
 * failure of the Cypress product may reasonably be expected to result in
 * significant property damage, injury or death ("High Risk Product"). By
 * including Cypress's product in a High Risk Product, the manufacturer
 * of such system or application assumes all risk of such use and in doing
 * so agrees to indemnify Cypress against all liability.
 */

/** @file
 *
 * GPIO API Application
 *
 * This application demonstrates how to use the WICED GPIO API
 * to toggle LEDs and read button states
 *
 * Features demonstrated
 *  - GPIO API
 *
 */

#include "wiced.h"
#include "Susi4.h"
#include "susi_adc.h"
#include "susi_gpio.h"
#include "susi_i2c.h"
#include "susi_pwm.h"
#include "susi_spi.h"

/******************************************************
 *                      Macros
 ******************************************************/

/******************************************************
 *                    Constants
 ******************************************************/

/******************************************************
 *                   Enumerations
 ******************************************************/

/******************************************************
 *                 Type Definitions
 ******************************************************/

/******************************************************
 *                    Structures
 ******************************************************/

/******************************************************
 *               Static Function Declarations
 ******************************************************/
void gpio_reconfig(void);
/******************************************************
 *               Variable Definitions
 ******************************************************/
extern platform_gpio_t platform_gpio_pins[] ;
/******************************************************
 *               Function Definitions
 ******************************************************/

void application_start( )
{
	wiced_bool_t result_led2;

    wiced_gpio_output_high( CB_PWR_ON );
    wiced_gpio_output_high( nCB_RESET_OUT);
    /* Initialise the WICED device */
    wiced_init();
    WPRINT_APP_INFO( ( "\r\n### Adv.susi_Test ###\r\n\r\n" ) );

    //SusiGPIOSetDirection(0, 0, SUSI_GPIO_OUTPUT);
    //SusiPWMSetPeriod(0, 500);
    //SusiPWMSetDutyCycle(0, 50);
    //wiced_pwm_init(WICED_PWM_1, 1000, 20);
    //wiced_pwm_start( WICED_PWM_1 );
    //simple_cli_loop(NULL);
    while ( 1 )
    {
        /*
        SusiGPIOSetLevel(0, 0, SUSI_GPIO_HIGH);
        wiced_rtos_delay_milliseconds( 1000 );
        SusiGPIOSetLevel(0, 0, SUSI_GPIO_LOW);
        */

        wiced_rtos_delay_milliseconds( 1000 );
    }
}
/****************************************************************************************/

