#include <stdio.h>
#include "wiced.h"
#include "Susi4.h"
#include "susi_gpio.h"



//static uint8_t gpioValue[GPIO_PIN_MAX];
//static GPIO_PinConfig	gpioConfig[GPIO_PIN_MAX];

// 	 ===============	Susi4	Standard	===================================
/* Condition									| Return Values 
// ---------------------------------------------+------------------------------
// Library Uninitialized						| SUSI_STATUS_NOT_INITIALIZED
// pValue==NULL)								| SUSI_STATUS_INVALID_PARAMETER
// Unknown Id									| SUSI_STATUS_UNSUPPORTED
// Else											| SUSI_STATUS_SUCCESS
*/
SusiStatus_t SUSI_API SusiGPIOGetCaps(
	SusiId_t Id,		/* IN		GPIO ID or Bank ID */
	uint32_t ItemId,	/* IN		Item ID */
	uint32_t *pValue	/* OUT		Item value */
	)
{
	SusiStatus_t Status = SUSI_STATUS_UNSUPPORTED;
		
	return 	Status;
}		


/* Condition									| Return Values 
// ---------------------------------------------+------------------------------
// Library Uninitialized						| SUSI_STATUS_NOT_INITIALIZED
// Bitmask==0 when Bank mode					| SUSI_STATUS_INVALID_PARAMETER
// pDirection==NULL								| SUSI_STATUS_INVALID_PARAMETER
// Unknown Id									| SUSI_STATUS_UNSUPPORTED
// (Bitmask&~(Inputs|Outputs))					| SUSI_STATUS_INVALID_BITMASK
// Else											| SUSI_STATUS_SUCCESS
*/
SusiStatus_t SUSI_API SusiGPIOGetDirection(
	SusiId_t Id,			/* IN		GPIO ID or Bank ID */
	uint32_t Bitmask,		/* INOPT	Bit mask of Affected Bits */
	uint32_t *pDirection	/* OUT		Current Direction */
    )
{
	SusiStatus_t 	Status = SUSI_STATUS_SUCCESS;

	UNUSED(Bitmask);
	
	if(Id>SUSI_GPIO_MAX || (SUSI_ID_GPIO_BANK_BASE & Id))
		return SUSI_STATUS_INVALID_PARAMETER;
	
	if(pDirection==NULL)
		return SUSI_STATUS_INVALID_DIRECTION;
	
		
	switch(Id)
	{	
		case 0:
		// Configure PIN_15 for GPIO Input, GPIO22  --> GPIO0
//	    ulPort = GPIOA2_BASE;
//	    ucPins = 0x40;
	    break;
    	case 1:
	    // Configure PIN_18 for GPIO Input, GPIO28  --> GPIO1
//	    ulPort = GPIOA3_BASE;
//	    ucPins = 0x10;
	    break;
	};

//	*pDirection = GPIODirModeGet( ulPort, ucPins );
	*pDirection = 1;

	return 	SUSI_STATUS_UNSUPPORTED;
}	    

/* Condition									| Return Values 
// ---------------------------------------------+------------------------------
// Library Uninitialized						| SUSI_STATUS_NOT_INITIALIZED
// Bitmask==0 when Bank mode					| SUSI_STATUS_INVALID_PARAMETER
// Unknown Id									| SUSI_STATUS_UNSUPPORTED
// (Bitmask&~(Inputs|Outputs))					| SUSI_STATUS_INVALID_BITMASK
// (Bitmask&Direction)&Inputs					| SUSI_STATUS_INVALID_DIRECTION
// (Bitmask&Direction)&Outputs					| SUSI_STATUS_INVALID_DIRECTION
// Else											| SUSI_STATUS_SUCCESS
*/
SusiStatus_t SUSI_API SusiGPIOSetDirection(
	SusiId_t Id,			/* IN		GPIO ID or Bank ID */
	uint32_t Bitmask,		/* INOPT	Bit mask of Affected Bits */
	uint32_t Direction		/* IN		Direction */
    )
{
	SusiStatus_t Status = SUSI_STATUS_SUCCESS;
	
	UNUSED(Bitmask);

	if(Id>SUSI_GPIO_MAX || (SUSI_ID_GPIO_BANK_BASE & Id))
		return SUSI_STATUS_INVALID_PARAMETER;

	if(Direction!=SUSI_GPIO_INPUT && Direction!=SUSI_GPIO_OUTPUT)
		return SUSI_STATUS_INVALID_DIRECTION;
	
	switch(Id)
	{	
		case 0:
			if(Direction==SUSI_GPIO_OUTPUT){
				platform_gpio_init( &platform_gpio_pins[WICED_LED1], OUTPUT_PUSH_PULL );
				platform_gpio_output_low( &platform_gpio_pins[WICED_LED1] );
			}
			else{
				platform_gpio_init( &platform_gpio_pins[WICED_LED1], INPUT_PULL_DOWN );
			}

	    break;
    	case 1:
			if(Direction==SUSI_GPIO_OUTPUT){
				platform_gpio_init( &platform_gpio_pins[WICED_LED2], OUTPUT_PUSH_PULL );
				platform_gpio_output_low( &platform_gpio_pins[WICED_LED2] );
			}
			else{
				platform_gpio_init( &platform_gpio_pins[WICED_LED2], INPUT_PULL_DOWN );
			}
	    break;
	};
	
	return 	Status;
}    
    
/* Condition									| Return Values 
// ---------------------------------------------+------------------------------
// Library Uninitialized						| SUSI_STATUS_NOT_INITIALIZED
// Bitmask==0 when Bank mode					| SUSI_STATUS_INVALID_PARAMETER
// pLevel==NULL									| SUSI_STATUS_INVALID_PARAMETER
// Unknown Id									| SUSI_STATUS_UNSUPPORTED
// (Bitmask&~(Inputs|Outputs))					| SUSI_STATUS_INVALID_BITMASK
// Else											| SUSI_STATUS_SUCCESS
*/
SusiStatus_t SUSI_API SusiGPIOGetLevel(
	SusiId_t Id,			/* IN		GPIO ID or Bank ID */
	uint32_t Bitmask,		/* INOPT	Bit mask of Affected Bits */
	uint32_t *pLevel		/* OUT		Current Level */
    )
{
	SusiStatus_t Status = SUSI_STATUS_SUCCESS;
	
	UNUSED(Bitmask);

	if(Id>SUSI_GPIO_MAX || (SUSI_ID_GPIO_BANK_BASE & Id))
		return SUSI_STATUS_INVALID_PARAMETER;
	
	if(pLevel==NULL)
		return SUSI_STATUS_INVALID_PARAMETER;
		
	switch(Id)
	{	
		case 0:
			*pLevel=(uint32_t)wiced_gpio_input_get(WICED_LED1);
	    break;
    	case 1:
    		*pLevel=(uint32_t)wiced_gpio_input_get(WICED_LED2);
	    break;
	};
		
	return 	Status;
}	    

/* Condition									| Return Values 
// ---------------------------------------------+------------------------------
// Library Uninitialized						| SUSI_STATUS_NOT_INITIALIZED
// Bitmask==0 when Bank mode					| SUSI_STATUS_INVALID_PARAMETER
// Unknown Id									| SUSI_STATUS_UNSUPPORTED
// Else											| SUSI_STATUS_SUCCESS
*/
SusiStatus_t SUSI_API SusiGPIOSetLevel(
	SusiId_t Id,			/* IN		GPIO ID or Bank ID */
	uint32_t Bitmask,		/* INOPT	Bit mask of Affected Bits */
	uint32_t Level			/* IN		Level */
    )
{    
	SusiStatus_t Status = SUSI_STATUS_SUCCESS;
	
	UNUSED(Bitmask);

	if(Id>SUSI_GPIO_MAX || (SUSI_ID_GPIO_BANK_BASE & Id))
		return SUSI_STATUS_INVALID_PARAMETER;

	if(Level!=SUSI_GPIO_HIGH && Level!=SUSI_GPIO_LOW)
		return SUSI_STATUS_INVALID_PARAMETER;
		
	switch(Id)
	{	
		case 0:
			if(Level==SUSI_GPIO_HIGH){
				wiced_gpio_output_high( WICED_LED1 );
			}
			else{
				wiced_gpio_output_low( WICED_LED1 );
			}
	    break;
    	case 1:
			if(Level==SUSI_GPIO_HIGH)
				wiced_gpio_output_high( WICED_LED2 );
			else
				wiced_gpio_output_low( WICED_LED2 );
	    break;
	};
		
	return 	Status;	
}

