#ifndef __SUSI_GPIO_H__
#define __SUSI_GPIO_H__

#ifdef __cplusplus
extern "C"
{
#endif

#define SUSI_GPIO_MAX 		2
#define SUSI_GPIO_MASK		0x3	

// typedef void (*GPIO_CallbackFxn)(void);
typedef void (*SUSIGPIO_CallbackFxn)(void);

#define SUSIGPIO_CFG_OUTPUT      	GPIO_CFG_OUTPUT      		//	Pin is an output. 
#define SUSIGPIO_CFG_OUT_STD      	GPIO_CFG_OUT_STD    		//	Output pin is not Open Drain 
#define SUSIGPIO_CFG_OUT_OD_NOPULL 	GPIO_CFG_OUT_OD_NOPULL 	   	//	Output pin is Open Drain 
#define SUSIGPIO_CFG_OUT_OD_PU      GPIO_CFG_OUT_OD_PU  	 	//	Output pin is Open Drain w/ pull up 
#define SUSIGPIO_CFG_OUT_OD_PD      GPIO_CFG_OUT_OD_PD   		//	Output pin is Open Drain w/ pull dn 

#define SUSIGPIO_CFG_OUT_HIGH       GPIO_CFG_OUT_HIGH			//	Set pin's output to 1.
#define SUSIGPIO_CFG_OUT_LOW        GPIO_CFG_OUT_LOW			//	Set pin's output to 0. 

#define SUSIGPIO_CFG_OUT_STR_LOW    GPIO_CFG_OUT_STR_LOW		//	OUT STRENGTH LOW
#define SUSIGPIO_CFG_OUT_STR_MED    GPIO_CFG_OUT_STR_MED		//	OUT STRENGTH MED
#define SUSIGPIO_CFG_OUT_STR_HIGH   GPIO_CFG_OUT_STR_HIGH		//	OUT STRENGTH HIGH

#define SUSIGPIO_CFG_INPUT          GPIO_CFG_INPUT 				//	Pin is an input.
#define SUSIGPIO_CFG_IN_NOPULL      GPIO_CFG_INPUT				//	Input pin has no PU/PD 
#define SUSIGPIO_CFG_IN_PU          GPIO_CFG_IN_PU				//	Input pin has Pullup
#define SUSIGPIO_CFG_IN_PD          GPIO_CFG_IN_PD 				// 	Input pin has Pulldown 

#define SUSIGPIO_CFG_IN_INT_NONE       	GPIO_CFG_IN_INT_NONE 		//	No Interrupt
#define SUSIGPIO_CFG_IN_INT_FALLING    	GPIO_CFG_IN_INT_FALLING 	//	Interrupt on falling edge
#define SUSIGPIO_CFG_IN_INT_RISING     	GPIO_CFG_IN_INT_RISING 		//	Interrupt on rising edge
#define SUSIGPIO_CFG_IN_INT_BOTH_EDGES 	GPIO_CFG_IN_INT_BOTH_EDGES 	//	Interrupt on both edges
#define SUSIGPIO_CFG_IN_INT_LOW        	GPIO_CFG_IN_INT_LOW 		//	Interrupt on low level
#define SUSIGPIO_CFG_IN_INT_HIGH      	GPIO_CFG_IN_INT_HIGH  		//	Interrupt on high level 

#define	SUSIGPIO_CFG_IN_INT_ONLY		GPIO_CFG_IN_INT_ONLY
#define	SUSIGPIO_DO_NOT_CONFIG			GPIO_DO_NOT_CONFIG

#ifdef __cplusplus
}
#endif

#endif // End of __SUSI_GPIO_H__
