#include "wiced.h"
#include "../simpleCli.h"
#include "Susi4.h"
#include "susiADCTest.h"
#include "susi_adc.h"

static int ADCRead(int index, char *string, int len, void *printer)
{
	float value;

	if(string != NULL && len != 0) return 0;

	SusiADCRead((SusiId_t)index, &value);

	console_printf("\r\n");
	console_printf("Susi ADC_%d Result: %d(mV)\n",index, (int)value);
	console_printf("\r\n");
	return true;
}

int ADCTest_Menu(int index, char *string, int len, void *printer) {
	if(string != NULL && len != 0) return 0;
    
	simple_cmds cmds[] = {
            { "ADC list" /*title*/,                 0,NULL },
            { "ADC_0",                              0,ADCRead },
            { "ADC_1",                              1,ADCRead },
            { "ADC_2",                              2,ADCRead },
            { "ADC_3",                              3,ADCRead },
            { NULL,                                 0,NULL }
    };
	return simple_cli_list(cmds);
}

int ADC_Auto_Test(int inx)
{
    SusiStatus_t result;
	uint16_t iVal;
	uint16_t iCmp[4]={ADC0_VOLTAGE, ADC1_VOLTAGE, ADC2_VOLTAGE, ADC3_VOLTAGE};
	float value;

	result=SusiADCRead((SusiId_t)inx, &value);

    if(result != SUSI_STATUS_SUCCESS){
    	console_printf("ADC_err1 ===> ");
    	return result;
    }

    iVal=(uint16_t)value;
    if(iVal > (iCmp[inx]*1.05) || iVal < (iCmp[inx]*0.95)){
    	console_printf("ADC_%d=%d(mv) ===>", inx, (int)iVal);
    	return -1;
    }

    return WICED_SUCCESS;
}


